<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
function destroy_change_state_popup(element)
{
	$('#change_state').remove();
	$('#change_state a').unbind('click');
}
function create_change_state_popup(element)
{
	if ($('#change_state').length)
		destroy_change_state_popup();

	$('body').append('<div id="change_state" style="position: absolute; left: '
		+ element.offset().left + 'px; top: ' + (element.offset().top + element.outerHeight())
		+ 'px; padding: 5px 10px; line-height: 1.5em; border: 1px solid #999999; background-color: #F5F5F5;">'
		+ '<a href="#"><span class="status-ok">Ok</span></a><br />'
		+ '<a href="#"><span class="status-warning">Warning</span></a><br />'
		+ '<a href="#"><span class="status-critical">Critical</span></a><br />'
		+ '<a href="#"><span class="status-unknown">Unknown</span></a></div>');
	var timer = setTimeout(destroy_change_state_popup, 5000);
}
$(document).ready(function(){
	$('.change_state').click(function(){
		var rows = $(this).parent().siblings();
		create_change_state_popup($(this));
		$('#change_state a').click(function(){
			var states = {Ok: 0, Warning: 1, Critical: 2, Unknown: 3};
			$.ajax({
				url: '<?php echo url::site(); ?>traps/change_state/',
				data: {
					host: $(rows).eq(1).text(),
					service: $(rows).eq(2).text(),
					tag: $(rows).eq(3).text(),
					state: states[$(this).text()]
				},
				cache: false,
				success: function(){
					location.reload();
				},
				error: function(){
					alert('An unexpected error occured!');
				}
			});
			return false;
		});
		return false;
	});
	$('.delete_trap').click(function(){
		if (confirm("Really delete?"))
		{
			var rows = $(this).parent().siblings();
			$.ajax({
				url: '<?php echo url::site(); ?>traps/delete/',
				data: {
					host: $(rows).eq(1).text(),
					service: $(rows).eq(2).text(),
					tag: $(rows).eq(3).text()
				},
				cache: false,
				success: function(){
					location.reload();
				},
				error: function(){
					alert('An unexpected error occured!');
				}
			});
		}
		return false;
	});
	$('.acknowledge').click(function(){
		if (confirm("Really  acknowledge?"))
		{
			var rows = $(this).parent().siblings();
			$.ajax({
				url: '<?php echo url::site(); ?>traps/acknowledge/',
				data: {
					host: $(rows).eq(1).text(),
					service: $(rows).eq(2).text(),
					tag: $(rows).eq(3).text()
				},
				cache: false,
				success: function(){
					location.reload();
				},
				error: function(){
					alert('An unexpected error occured!');
				}
			});
		}
		return false;
	});
});
</script>
<div id="content_header">
	<div id="page_links">
		<ul>
			<li><a href="<?php echo url::base(); ?>application/views/themes/default/traps/op5-trapper-admin-manual.pdf">Manual</a></li>
			<?php
				if ($logs_number)
				{
					echo '<li style="float: right;">There are ';
					echo html::anchor('traps/logs/', "$logs_number error(s)");
					echo '</li>';
				}
			?>
			<li><?php echo $problems_only ? html::anchor('traps/all/', 'All') : '<strong>All</strong>'; ?></li>
			<li><?php echo $problems_only ? '<strong>Problems only</strong>' : html::anchor('traps/problems/', 'Problems only'); ?></li>
		</ul>
	</div>
	<div class="clear"></div>
</div>
<div id="traps">
	<table id="snmp_traps_table">
		<caption><?php echo $title ?></caption>
		<thead>
			<tr>
				<?php
				$fields = array('time', 'host', 'service', 'tag', 'state', 'count', 'trapoid', 'message', 'trap');
				foreach ($fields as $field)
				{
					if ($field == $sortby)
						$direction = ($order == 'asc')? 'SortDown' : 'SortUp';
					else
						$direction = '';
					echo "<th class=\"{$direction}\" onclick=\"location.href='"
						. url::site() . "traps/?sortby={$field}&amp;order=" . ($order == 'asc' ? 'desc' : 'asc')
						. "'\">{$labels[$field]}</th>";
				}
				?>
				<th><?php echo $labels['actions']; ?></th>
			</tr>
		</thead>
		<tbody>
			<?php $odd = true; foreach ($traps_data as $trap) { ?>
			<tr class="<?php echo $odd ? 'odd' : 'even'; ?>">
				<td><?php echo $trap['time']; ?></td>
				<td><?php echo html::anchor('extinfo/details/host/' . $trap['host'], $trap['host']); ?></td>
				<td><?php echo html::anchor('extinfo/details/service/' . $trap['host'] . '?service=' . $trap['service'], $trap['service']); ?></td>
				<td><?php echo $trap['tag']; ?></td>
				<td class="icon <?php echo strtolower(Current_status_Model::status_text($trap['state'], 'service')); ?>">
					<?php if ($trap['acknowledged']) {
						echo html::image($this->add_path('icons/16x16/acknowledged.png'), array('alt' => _('Acknowledged'), 'title' => _('Acknowledged')));
					} ?>
					<span class="icon-16 x16-shield-<?php echo strtolower(Current_status_Model::status_text($trap['state'], true, 'service')); ?>"></span>
				</td>
				<td><?php echo $trap['count']; ?></td>
				<td><?php echo $trap['trapoid']; ?></td>
				<td style="white-space: normal;"><?php echo $trap['message']; ?></td>
				<td width="100%" style="white-space: normal;"><?php echo $trap['trap']; ?></td>
				<td style="text-align: center;"><a href="#" class="delete_trap">Delete</a></td>
			</tr>
			<?php $odd = !$odd; } ?>
		</tbody>
	</table>
</div>
